apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  name: kube-linter
spec:
  description: >-
    This task makes it possible to use kube-linter within Tekton Pipeline.

    The KubeLinter tool by StackRox is an open-source command-line interface to identify misconfigurations in Kubernetes objects.
    KubeLinter offers the ability to integrate checks on Kubernetes YAML files and Helm charts before deployment into a Kubernetes cluster.
    With 31 standard built-in checks and the room to configure your own, you get immediate feedback about misconfigurations and Kubernetes security violations.
  workspaces:
    - name: source
      description: A workspace that contains fetched git repo.
  params:
    - name: config_map
      type: string
      description: Config map containing the kube-linter config. Key shall be kubelinter.yaml.
      default: ""
    - name: manifest
      type: string
      description: path to manifest files or manifest directory to be checked.
      default: "."
    - name: output_format
      type: string
      description: format in which report will be generated. (json|sarif|plain) (default:"json")
      default: json
    - name: output_file
      type: string
      description: Where to write the output.
  steps:
    - env:
      - name: HOME
        value: /tekton/home
      name: lint-yaml
      image: docker.io/stackrox/kube-linter:0.2.6-13-g733e927089-alpine
      workingDir: $(workspaces.source.path)
      script: |
        ../../kube-linter lint  "$(params.manifest)" --config "/config/kubelinter.yaml" --format "$(params.output_format)" | tee "$(params.output_file)"
      volumeMounts:
      - name: config
        mountPath: "/config"
        readOnly: true
  volumes:
    - name: config
      configMap:
        name: $(params.config_map)
